"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class GenomicFeature(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "ensemblId",
        "featureType",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "featureType": reports_3_0_0.FeatureTypes,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "org.gel.models.report.avro.FeatureTypes": reports_3_0_0.FeatureTypes,
            "org.gel.models.report.avro.GenomicFeature": reports_3_0_0.GenomicFeature,
        }

    __slots__ = [
        "ensemblId",
        "featureType",
        "HGNC",
        "other_ids",
    ]

    def __init__(
        self,
        ensemblId,
        featureType,
        HGNC=None,
        other_ids=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_3_0_0.GenomicFeature model.

        :param ensemblId:
            Transcript used, this should be a feature ID from Ensembl, (i.e,
            ENST00000544455)
        :type ensemblId: str
        :param featureType:
            Feature Type
        :type featureType: FeatureTypes
        :param HGNC:
            This field is optional, BUT it should be filled if possible
        :type HGNC: None | str
        :param other_ids:
            Others IDs
        :type other_ids: None | dict[str, str]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
